#!/bin/bash
# -*- mode: sh; fill-column: 75; tab-width: 8; coding: utf-8-unix -*-

prog=$( basename $0 .bash )
ROLE=base
. /usr/local/bin/usr_local_tput.bash || exit 2

[ "$DEBUG" = 1 ] && patch=patch || patch=echo

TODIR=/
[ $# -eq 0 ]  && set -- *

INFO patching $@ in $PWD
find "$@" -name \*.diff |while read file ; do
    echo $file
    relf=$( echo $file | sed -e 's/^root//' )
    base=$( echo $relf | sed -e 's/.diff$//' )
    dest="${TODIR}$base"

    if [ ! -f $dest ] && head -1 $file | grep -q /dev/null ; then
	cp /dev/null $dest
	$patch -b -z .dst $dest < $file
	continue
    fi
    if [ ! -f $dest ]  ; then
	WARN BAD PATCH file missing dest=$dest for patch $file
	continue
    fi
    if [ -f $dest.dst ] ; then
	[ $dest -nt $file ] && DBUG $dest.dst done || WARN $dest -nt $PWD/$file
	continue
    fi

    $patch -b -z .dst $dest < $file 2>$base.err
    retval=$?
    if [ $? -eq 0 ] ; then
		INFO patched $file
	    else
		WARN patch ERROR $file `cat $base.err`
	        [ -s $base.err ] || rm -f $base.err
	    fi
    [ -f $dest.rej ] && WARN $dest.rej exists
done
exit 0
